"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var UniqueReducible_1 = require('../UniqueReducible');
var Includer_1 = require('./Includer');
var Filterer_1 = require('./Filterer');
var Attributor_1 = require('./Attributor');
var Orderer_1 = require('./Orderer');
var SubQuerier = (function (_super) {
    __extends(SubQuerier, _super);
    function SubQuerier(subquery) {
        _super.call(this);
        if (subquery === null) {
            return;
        }
        this._model = subquery.model;
        this._alias = subquery.alias;
        this._includer = new Includer_1.default(subquery.include);
        this._filterer = new Filterer_1.default(subquery.filters);
        this._attributor = new Attributor_1.default(subquery.attributes);
        this._orderer = new Orderer_1.default(subquery.order);
    }
    Object.defineProperty(SubQuerier.prototype, "model", {
        get: function () {
            return this._model;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "alias", {
        get: function () {
            return this._alias;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "includer", {
        get: function () {
            return this._includer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "filterer", {
        get: function () {
            return this._filterer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "attributor", {
        get: function () {
            return this._attributor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "orderer", {
        get: function () {
            return this._orderer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubQuerier.prototype, "plain", {
        get: function () {
            var subquery = {};
            subquery.model = this._model;
            subquery.alias = this._alias;
            var include = this._includer.plain;
            if (include !== null) {
                subquery.include = include;
            }
            var filters = this._filterer.plain;
            if (filters !== null) {
                subquery.filters = filters;
            }
            var attributes = this._attributor.plain;
            if (attributes !== null) {
                subquery.attributes = attributes;
            }
            var order = this._orderer.plain;
            if (order !== null) {
                subquery.order = order;
            }
            return subquery;
        },
        enumerable: true,
        configurable: true
    });
    SubQuerier.prototype.reduce = function (action) {
        var includer = this._includer.reduce(action);
        var filterer = this._filterer.reduce(action);
        var attributor = this._attributor.reduce(action);
        var orderer = this._orderer.reduce(action);
        if (includer !== this._includer ||
            filterer !== this._filterer ||
            attributor !== this._attributor ||
            orderer !== this._orderer) {
            var clone = this.clone();
            clone._includer = includer;
            clone._filterer = filterer;
            clone._attributor = attributor;
            clone._orderer = orderer;
            return clone;
        }
        return this;
    };
    SubQuerier.prototype.cloneOverride = function (clone) {
        _super.prototype.cloneOverride.call(this, clone);
        clone._model = this._model;
        clone._alias = this._alias;
        clone._includer = this._includer;
        clone._filterer = this._filterer;
        clone._attributor = this._attributor;
        clone._orderer = this._orderer;
    };
    SubQuerier.prototype.createInstance = function () {
        return new SubQuerier(null);
    };
    return SubQuerier;
}(UniqueReducible_1.default));
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = SubQuerier;
